; 2D in 3D

Function MakeSprite.sprite(img,w=16,h=16,parent=0)
	w=w/2
	h=h/2
	If parent=0 Then FlatPack=CreateMesh()
	If parent<>0 Then FlatPack=CreateMesh(parent)
		Surface=CreateSurface(FlatPack)
		    AddVertex surface,-w,-h,0,0,0
		    AddVertex surface,w,-h,0,1,0
		    AddVertex surface,w,h,0,1,1
		    AddVertex surface,-w,h,0,0,1 
		    AddTriangle surface,0,1,2
		    AddTriangle surface,0,2,3
		UpdateNormals FlatPack
	EntityTexture flatpack,img
	a.sprite=New sprite
	a\ent=flatpack
	a\x=400
	a\y=300
	a\rot=0
	a\alpha=1
	a\r=255
	a\g=255
	a\b=255
	a\order=0
	Return a.sprite
End Function


.Setup2D3D
	campivot=CreatePivot()
	cam=CreateCamera(campivot)
	PositionEntity cam,0,0,400
	PointEntity cam,campivot
	PositionEntity campivot,400,300,0
	RotateEntity cam,180,0,0
	AmbientLight 255,255,255

	Type Sprite
		Field x#,y#
		Field Order
		Field ent
		Field rot#,alpha#
		Field r,g,b
	End Type
Return


Function Render2D3D()
	For a.sprite=Each sprite
		PositionEntity a\ent,a\x,a\y,a\Order
		RotateEntity a\ent,0,0,a\rot
		EntityAlpha a\ent,a\alpha
		EntityColor a\ent,a\r,a\g,a\b
	Next
	RenderWorld
End Function


.ShowRoughFramerate
	ttr=MilliSecs()-lf
	If ttr=0 Then ttr=1
	fps=(1000/ttr)
	Text 1,1,fps
	lf=MilliSecs()
Return


Function FreeSprite(a.sprite)
	FreeEntity a\ent
	Delete a.sprite
End Function

