Graphics3D 800,600,32,2
SetBuffer BackBuffer()

; Do this early on, so that everything's ready to go..
Gosub Setup2D3D


SeedRnd MilliSecs()

SpritesToDraw=250

; Set up your array, ready for use
Dim obj.sprite(1000)

; Load in some textures
Arrow_Texture=LoadTexture("system/m004/nothing.png")
Circle_Texture=LoadTexture("system/m004/nothingelse.png")


For n=1 To SpritesToDraw
	;Pick one of our textures
	TextureToUse=Arrow_Texture
	If Rand(1,2)=1 Then TextureToUse=Circle_Texture

	;Make us some Sprites using MakeSprite(Texture,width,height ,[parent] )
	
	Obj.sprite(n)=MakeSprite(TextureToUse,Rand(16,64),Rand(16,64))
	
Next


For n=1 To SpritesToDraw
	;Each .sprite object has the following settings.
	
	obj(n)\x=Rand(0,800)	;X co-ord.
	obj(n)\y=Rand(0,600)	;Y co-ord.
	obj(n)\order=Rnd(-40,40)	;basically the Z co-ord, where bigger = closer = "drawn on top"
								; Although you should try to keep things seperate,
								; you'll also want to ensure you don't go overboard.
								; Otherwise you'll have sprite scaling issues.
							
	obj(n)\rot=Rand(0,360)	;Rotation (in 2D)
		
	obj(n)\r=Rand(100,255)	;Color setting	R
	obj(n)\g=Rand(100,255)	;				G
	obj(n)\b=Rand(100,255)	;				B
	obj(n)\alpha=Rnd(0.5,1)	;Alpha, 0-1

							;You can also use \ent for raw entity access.
Next


	
Repeat

	;Main Stuff
	Cls
	
	For n=1 To 100
		obj(n)\rot=obj(n)\rot+2	; Rotate some of them.
	Next
	
	Render2D3D		; Render
	Gosub ShowRoughFramerate
	Flip

	;----------------------
	
	;Extra Stuff

	;Camera
	; If you want to do fancy camera things, Cam and CamPivot are available for use.
	; Do note, however, that none of the sprites show up from the back!
	RotateEntity campivot,0,0,0
	If MouseDown(1) Then RotateEntity campivot,(MouseY()/(600/90))-45,(MouseX()/(800/90))-45,0
	

	
	;Deleting
	; Although a FreeSprite command exists, 
	; You're in charge of keeping track of what's left over.
	; Otherwise, if you try to re-delete (or even access) the same sprite again
	; you get a "Object does not exist" message.
	; That's Types for you!
	If KeyDown(14) And deleted=0
		For n=101 To SpritesToDraw
			FreeSprite obj(n).sprite
		Next
		deleted=1		
	EndIf
	

If KeyDown(1) Then endofgame=99
Until endofgame<>0



Include "2Din3D.bb"
